﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration


Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Me.BindDetailsView()
        End If
    End Sub

    Private Sub BindDetailsView()
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand("SELECT CustomerId, Name, Country FROM Customers", con)
                Using sda As New SqlDataAdapter(cmd)
                    Using dt As New DataTable()
                        sda.Fill(dt)
                        DetailsView1.DataSource = dt
                        DetailsView1.DataBind()
                    End Using
                End Using
            End Using
        End Using
    End Sub

    Protected Sub OnItemCreated(sender As Object, e As EventArgs)
        Dim commandRowIndex As Integer = DetailsView1.Rows.Count - 1
        If commandRowIndex <> -1 Then
            Dim row As DetailsViewRow = DetailsView1.Rows(commandRowIndex)
            Dim btnDelete As Button = row.Controls(0).Controls.OfType(Of Button)().Where(Function(b) b.CommandName = "Delete").FirstOrDefault()
            btnDelete.Attributes("onclick") = "if(!confirm('Do you want to delete this Customer?')){ return false; };"
        End If
    End Sub

    Protected Sub OnItemDeleting(sender As Object, e As DetailsViewDeleteEventArgs)
        Dim customerId As Integer = Integer.Parse(DetailsView1.Rows(0).Cells(1).Text)
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand("DELETE FROM Customers WHERE CustomerId = @CustomerId", con)
                cmd.Parameters.AddWithValue("@CustomerId", customerId)
                con.Open()
                cmd.ExecuteNonQuery()
                con.Close()
            End Using
        End Using
        Me.BindDetailsView()
    End Sub

    Protected Sub OnPageIndexChanging(sender As Object, e As DetailsViewPageEventArgs)
        DetailsView1.PageIndex = e.NewPageIndex
        Me.BindDetailsView()
    End Sub
End Class

